/*
 * Copyright (c) 1992, by FORTE
 *
 * This software is furnished under a license and may be used,
 * copied, or disclosed only in accordance with the terms of such
 * license and with the inclusion of the above copyright notice.
 * This software or any other copies thereof may not be provided or
 * otherwise made available to any other person. No title to and
 * ownership of the software is hereby transfered.
 */

#include "common.h"


void UltraMidiXmit (uint8_t data)
{
	outportb (_gf1_data.midi_data, data);

	return;
}

uint8_t UltraMidiRecv (void)
{
	return inportb (_gf1_data.midi_data);
}

uint8_t UltraMidiStatus (void)
{
	return inportb (_gf1_data.midi_control);
}

void UltraMidiEnableRecv (void)
{
	_gf1_data.image_midi |= MIDI_ENABLE_RCV;
	outportb (_gf1_data.midi_control, _gf1_data.image_midi);

	return;
}

void UltraMidiEnableXmit (void)
{
	_gf1_data.image_midi |= MIDI_ENABLE_XMIT;
	outportb (_gf1_data.midi_control, _gf1_data.image_midi);

	return;
}

void UltraMidiDisableRecv (void)
{
	_gf1_data.image_midi &= ~MIDI_ENABLE_RCV;
	outportb (_gf1_data.midi_control, _gf1_data.image_midi);

	return;
}

void UltraMidiDisableXmit (void)
{
	_gf1_data.image_midi &= ~MIDI_ENABLE_XMIT;
	outportb (_gf1_data.midi_control, _gf1_data.image_midi);

	return;
}

void UltraMidiReset (void)
{
	_gf1_data.image_midi = 0;
	outportb (_gf1_data.midi_control, MIDI_RESET);

	gf1_delay ();

	outportb (_gf1_data.midi_control, 0x00);

	return;
}
