/*
 * Copyright (c) 1992, by FORTE
 *
 * This software is furnished under a license and may be used,
 * copied, or disclosed only in accordance with the terms of such
 * license and with the inclusion of the above copyright notice.
 * This software or any other copies thereof may not be provided or
 * otherwise made available to any other person. No title to and
 * ownership of the software is hereby transfered.
 */

#include "common.h"


void UltraStartTimer (int timer, uint8_t time)
{
	uint8_t temp;

	if (timer == 1)
	{
		_gf1_data.timer_ctrl |= 0x04;
		_gf1_data.timer_mask |= 0x01;
		temp = TIMER1;
	}
	else
	{
		_gf1_data.timer_ctrl |= 0x08;
		_gf1_data.timer_mask |= 0x02;
		temp = TIMER2;
	}

	ENTER_CRITICAL;

	time = 256 - time;
	outportb (_gf1_data.reg_select, temp);
	outportb (_gf1_data.data_hi, time);

	outportb (_gf1_data.reg_select, TIMER_CONTROL);
	outportb (_gf1_data.data_hi, _gf1_data.timer_ctrl);

	outportb (_gf1_data.timer_control, 0x04);
	outportb (_gf1_data.timer_data, _gf1_data.timer_mask);

	LEAVE_CRITICAL;
}


void UltraStopTimer (int timer)
{
	if (timer == 1)
	{
		_gf1_data.timer_ctrl &= ~0x04;
		_gf1_data.timer_mask &= ~0x01;
	}
	else
	{
		_gf1_data.timer_ctrl &= ~0x08;
		_gf1_data.timer_mask &= ~0x02;
	}

	ENTER_CRITICAL;

	outportb (_gf1_data.reg_select, TIMER_CONTROL);
	outportb (_gf1_data.data_hi, _gf1_data.timer_ctrl);

	outportb (_gf1_data.timer_control, 0x04);
	outportb (_gf1_data.timer_data, _gf1_data.timer_mask  | 0x80);

	LEAVE_CRITICAL;
}


int UltraTimerStopped (int timer)
{
	uint8_t temp;

	if (timer == 1)
		temp = 0x40;
	else
		temp = 0x20;

	return inportb (_gf1_data.timer_control) & temp;
}
